Subject: Re: one more... iproute commands lockup whole system

From: Patrick McHardy <[email-masked]>
Date: Wed, 04 Apr 2007 15:36:54 +0200

jamal wrote:
> On Wed, 2007-04-04 at 05:11 +0300, Denys wrote:
> 
>>I think this highly useful feature given by jamal, difficult to be avoided 
>>from crash, if user not enough experienced in networking(like me). I guess 
>>packet can be even not ipv4/ipv6 packet, maybe it can be cloned IPX or ARP, 
>>so TTL field cannot be used.

We have a loop counter (RTTL) in tc_verd. For some reason it is reset
after ing_filter though.

> I checked maybe sk_buff have some fields, seems 
>>also bad luck, if there can be something like "internal" counter for packet, 
>>how much times it got redirected, it will help. 
> 
> 
> Adding a field in the skb that keeps track of things would work well,
> but would be a controvesial thing to do because it actually requires a
> vector not just one field. There is a filed called cb[] but it cant be
> used in this case because every time we redirect it could be trampled.

It would be interesting to find out what the problem is exactly.
The configuration itself looks harmless, so I'm guessing its
rather a deadlock than a loop.